module App_passwd

open Data
open Record 

type UserName = str
type ServerName = str
type CertName = str

#if fs
val clientPasswd: ServerName -> unit
val serverPasswd: ServerName -> CertName -> unit -> unit
val insertPasswd: UserName -> ServerName -> bytes -> unit
#else
val sendPasswd: ConnectionId -> UserName -> ServerName -> unit
val recvPasswd: ConnectionId -> ServerName -> unit
val sendFakePasswd: ConnectionId -> UserName -> ServerName -> bytes -> unit
#endif

#if paper
(*--- interfacePasswdBegin *)
val generatePasswd: UserName -> ServerName -> unit
val clientPasswd: UserName -> ServerName -> unit
val serverPasswd: ServerName -> unit
(*--- interfacePasswdEnd *)
#endif

